VERSION 2.00
Begin Form MainForm 
   BackColor       =   &H00C0C0C0&
   Caption         =   "PIC Scope"
   ClientHeight    =   2625
   ClientLeft      =   105
   ClientTop       =   3525
   ClientWidth     =   9105
   Height          =   3315
   Left            =   45
   LinkTopic       =   "Form1"
   ScaleHeight     =   175
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   607
   Top             =   2895
   Width           =   9225
   Begin ComboBox TimeScale 
      Height          =   300
      Left            =   7920
      Style           =   2  'Dropdown List
      TabIndex        =   11
      Top             =   120
      Width           =   975
   End
   Begin ComboBox ChnNo 
      Height          =   300
      Left            =   5040
      Style           =   2  'Dropdown List
      TabIndex        =   9
      Top             =   120
      Width           =   615
   End
   Begin ComboBox NoOfChn 
      Height          =   300
      Left            =   3360
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   120
      Width           =   615
   End
   Begin ComboBox BitPos 
      Height          =   300
      Left            =   6240
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   120
      Width           =   615
   End
   Begin TextBox Lines 
      Height          =   285
      Left            =   960
      TabIndex        =   3
      Top             =   120
      Width           =   615
   End
   Begin CommandButton Load 
      Caption         =   "Load"
      Height          =   252
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   732
   End
   Begin HScrollBar HScroll 
      Height          =   255
      Left            =   720
      TabIndex        =   1
      Top             =   2160
      Width           =   7215
   End
   Begin PictureBox Scope 
      Height          =   1215
      Left            =   720
      ScaleHeight     =   79
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   471
      TabIndex        =   0
      Top             =   840
      Width           =   7095
   End
   Begin Label Label5 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Time/div"
      Height          =   255
      Left            =   7080
      TabIndex        =   12
      Top             =   165
      Width           =   855
   End
   Begin Label Label4 
      Alignment       =   1  'Right Justify
      BackColor       =   &H00C0C0C0&
      Caption         =   "Chn No."
      Height          =   255
      Left            =   4200
      TabIndex        =   10
      Top             =   165
      Width           =   735
   End
   Begin Label Label3 
      Alignment       =   1  'Right Justify
      BackColor       =   &H00C0C0C0&
      Caption         =   "No. of Chn"
      Height          =   255
      Left            =   2280
      TabIndex        =   8
      Top             =   165
      Width           =   975
   End
   Begin Label Label2 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Bit"
      Height          =   255
      Left            =   5880
      TabIndex        =   6
      Top             =   165
      Width           =   375
   End
   Begin Label Label1 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Lines"
      Height          =   255
      Left            =   1680
      TabIndex        =   4
      Top             =   165
      Width           =   495
   End
   Begin Menu File 
      Caption         =   "&File"
      Begin Menu FileOpen 
         Caption         =   "&Open..."
      End
      Begin Menu FileExit 
         Caption         =   "E&xit"
      End
   End
End
Option Explicit

Dim PinStat(2000) As String
Dim PinStatInx As Integer
Dim FirstStat As Integer
Dim ScScale As Integer
Dim ChanList(8) As String
Dim tic As Integer

Dim ListInx As Integer

Sub BitPos_Change ()
  ChanList(ChnNo.ListIndex) = BitPos.List(BitPos.ListIndex)
End Sub

Sub BitPos_Click ()
  If ListInx <> BitPos.ListIndex Then
    Call BitPos_Change
  End If
End Sub

Sub BitPos_GotFocus ()
  ListInx = BitPos.ListIndex
End Sub

Sub BitPos_KeyPress (KeyAscii As Integer)
  If ListInx <> BitPos.ListIndex Then
    Call BitPos_Change
  End If
End Sub

Sub ChnNo_Change ()
  If ChanList(ChnNo.ListIndex) = "" Then
    ChanList(ChnNo.ListIndex) = "0"
    BitPos.ListIndex = 0
  Else
    BitPos.ListIndex = Val(ChanList(ChnNo.ListIndex))
  End If

  ListInx = ChnNo.ListIndex
End Sub

Sub ChnNo_Click ()
  If ListInx <> ChnNo.ListIndex Then
    Call ChnNo_Change
  End If
End Sub

Sub ChnNo_GotFocus ()
  ListInx = ChnNo.ListIndex
End Sub

Sub ChnNo_KeyPress (KeyAscii As Integer)
  If ListInx <> ChnNo.ListIndex Then
    Call ChnNo_Change
  End If
End Sub

Sub DispChannel (ChnNo As Integer)
  Dim i As Integer, Channels As Integer
  Dim Offset As Single
  Dim PinTime As Single
  Dim TraceTop As Integer, TraceHeight As Integer
  Dim TimeInx As Integer
  Dim Pos As Integer, Value As Integer
  Dim PortVal As Integer, OldPinVal As Integer, PinVal As Integer
  Dim ScrPinTime As Integer, OldScrPinTime As Integer

  Channels = NoOfChn.ListIndex + 1
  TraceHeight = (Scope.ScaleHeight / Channels) * 8 / 10
  TraceTop = (Scope.ScaleHeight / Channels) / 10 + (Scope.ScaleHeight / Channels) * ChnNo
  Offset = HScroll.Value

  If ChanList(ChnNo) <> "" Then
    Scope.DrawWidth = 1
    i = 0
    TimeInx = 0
    OldScrPinTime = 0
    ScrPinTime = 0
    OldPinVal = 2
    Pos = Val(ChanList(ChnNo))
    Do
      If (ScrPinTime > Scope.ScaleWidth) Or (TimeInx >= PinStatInx) Then
        Exit Do
      End If
      ' Scan thru buffer to look for change in state
      Do
        PinTime = Val(PinStat(TimeInx))
        PortVal = Val("&H" & Mid(PinStat(TimeInx), InStr(PinStat(TimeInx), "|") + 1))
        PinVal = GetBit(PortVal, Pos)
        TimeInx = TimeInx + 1
        If (TimeInx >= PinStatInx) Then
          Exit Do
        End If
      Loop While PinVal = OldPinVal
      OldPinVal = PinVal
      ScrPinTime = (PinTime - Offset) * tic / ScScale
      If PinVal = 0 Then
        Scope.ForeColor = QBColor(4)
        Scope.DrawWidth = 2
        Scope.Line (OldScrPinTime, TraceTop)-(OldScrPinTime, TraceTop + TraceHeight)
        Scope.Line (OldScrPinTime, TraceTop + TraceHeight)-(ScrPinTime, TraceTop + TraceHeight)
        Scope.ForeColor = QBColor(0)
        Scope.DrawWidth = 1
      Else
        Scope.ForeColor = QBColor(4)
        Scope.DrawWidth = 2
        Scope.Line (OldScrPinTime, TraceTop + TraceHeight)-(OldScrPinTime, TraceTop)
        Scope.Line (OldScrPinTime, TraceTop)-(ScrPinTime, TraceTop)
      End If
      OldScrPinTime = ScrPinTime
    Loop
  End If
End Sub

Sub Form_Load ()
  Dim i As Integer

  tic = 10
  ScScale = 53

  For i = 0 To 7
    BitPos.AddItem (Format(i))
  Next i
  BitPos.ListIndex = 0
  
  For i = 1 To 8
    NoOfChn.AddItem (Format(i))
  Next i
  NoOfChn.ListIndex = 0

  ChnNo.AddItem ("1")
  ChnNo.ListIndex = 0

  ChanList(0) = "0"

  ' Load time scale
  TimeScale.AddItem ("10 us")
  TimeScale.ItemData(TimeScale.NewIndex) = 10
  TimeScale.AddItem ("50 us")
  TimeScale.ItemData(TimeScale.NewIndex) = 50
  TimeScale.AddItem ("100 us")
  TimeScale.ItemData(TimeScale.NewIndex) = 100
  TimeScale.AddItem ("500 us")
  TimeScale.ItemData(TimeScale.NewIndex) = 500
  TimeScale.AddItem ("1200 baud")
  TimeScale.ItemData(TimeScale.NewIndex) = 833
  TimeScale.AddItem ("1 ms")
  TimeScale.ItemData(TimeScale.NewIndex) = 1000
  TimeScale.AddItem ("5 ms")
  TimeScale.ItemData(TimeScale.NewIndex) = 5000
  TimeScale.ListIndex = 0
End Sub

Sub Form_Resize ()
  Dim Border As Integer, TopMargin As Integer

  Border = 5
  TopMargin = 40

  Scope.Height = MainForm.ScaleHeight - Border - HScroll.Height - TopMargin + 1
  Scope.Width = MainForm.ScaleWidth - (2 * Border)
  Scope.Left = Border
  Scope.Top = TopMargin
  
  HScroll.Height = 16
  HScroll.Width = MainForm.ScaleWidth - (2 * Border)
  HScroll.Top = Scope.Top + Scope.ScaleHeight - 1
  HScroll.Left = Border
  
  Call Scope_paint
End Sub

Function GetBit (ByteVal As Integer, Pos As Integer) As Integer
  Dim Pow2 As Integer, i As Integer

  Pow2 = 1
  For i = 1 To Pos
    Pow2 = Pow2 * 2
  Next i

  GetBit = Int((ByteVal Mod (Pow2 * 2)) / Pow2)
End Function

Sub HScroll_Change ()
  Call Scope_paint
End Sub

Sub Load_Click ()
  Dim FNum As Integer
  Dim FName As String, InpChar As String, InpLine As String
  Dim NoOfLines As Long
  Dim InpTime As Single, PortVal As String

  FNum = FreeFile
  FName = "c:\prashb\train\dcc\pic_cmd\portb.trc"
  Open FName For Input Access Read As FNum
  InpLine = ""
  NoOfLines = 0
  PinStatInx = 0
  Do While Not EOF(FNum)
    InpChar = Input(1, FNum)
    If InpChar <> Chr(10) Then
      InpLine = InpLine & InpChar
    Else
      ' Get a time
      InpTime = Val(Mid(InpLine, InStr(1, InpLine, "|") + 1))
      PortVal = Mid(InpLine, InStr(1, InpLine, "PORTB:") + 6, 2)
      PinStat(PinStatInx) = InpTime & "|" & PortVal
      PinStatInx = PinStatInx + 1

      InpLine = ""
      NoOfLines = NoOfLines + 1
      Lines.Text = NoOfLines
      If NoOfLines Mod 500 = 0 Then
        DoEvents
      End If
    End If
  Loop

  HScroll.Min = 0
  HScroll.Max = InpTime
  HScroll.Value = 0
  HScroll.SmallChange = ScScale
  HScroll.LargeChange = ScScale * 10

  Close
  Call Scope_paint
End Sub

Sub NoOfChn_Change ()
  Dim i As Integer

  For i = 0 To ChnNo.ListCount - 1
    ChnNo.RemoveItem (0)
  Next i
  For i = 0 To NoOfChn.ListIndex
    ChnNo.AddItem (Format(i + 1))
    ChnNo.ListIndex = 0
  Next i
  ListInx = NoOfChn.ListIndex
End Sub

Sub NoOfChn_Click ()
  If ListInx <> NoOfChn.ListIndex Then
    Call NoOfChn_Change
  End If
End Sub

Sub NoOfChn_GotFocus ()
  ListInx = NoOfChn.ListIndex
End Sub

Sub NoOfChn_KeyPress (KeyAscii As Integer)
  If ListInx <> NoOfChn.ListIndex Then
    Call NoOfChn_Change
  End If
End Sub

Sub Scope_paint ()
  Dim chn As Integer
  Dim Channels As Integer
  Dim i As Integer

  Scope.Cls
  Channels = NoOfChn.ListIndex + 1

  Scope.ForeColor = RGB(222, 222, 222)
  For i = 1 To Int(Scope.ScaleWidth / tic)
    Scope.Line (i * tic, 0)-(i * tic, Scope.ScaleHeight)
  Next i
  Scope.ForeColor = QBColor(0)

  For chn = 0 To Channels - 1
    DispChannel (chn)
  Next chn
End Sub

Sub TimeScale_Change ()
  ScScale = TimeScale.ItemData(TimeScale.ListIndex)
  Call Scope_paint
  ListInx = TimeScale.ListIndex
End Sub

Sub TimeScale_Click ()
  If ListInx <> TimeScale.ListIndex Then
    Call TimeScale_Change
  End If
End Sub

Sub TimeScale_GotFocus ()
  ListInx = TimeScale.ListIndex
End Sub

Sub TimeScale_KeyPress (KeyAscii As Integer)
  If ListInx <> TimeScale.ListIndex Then
    Call TimeScale_Change
  End If
End Sub

